ur_rna.RNAstructureUI.windows

## Class PredictWindowBase

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JInternalFrame
        - - ur_rna.RNAstructureUI.windows.InternalWindow
          - - ur_rna.RNAstructureUI.windows.PredictWindowBase

- All Implemented Interfaces:
    java.awt.event.ActionListener, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.util.EventListener, javax.accessibility.Accessible, javax.swing.RootPaneContainer, javax.swing.WindowConstants
  Direct Known Subclasses:
    PredictBimolStructureWindow, PredictMultiStructureWindow, PredictSingleStructureWindow, PredictTwoStructureWindow

      public abstract class PredictWindowBase
      extends InternalWindow

  A base class for the Structure Prediction Windows
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static interface` | `PredictWindowBase.BackgroundTask`
    `(package private) class` | `PredictWindowBase.FieldInfo`
    `(package private) class` | `PredictWindowBase.FileFieldInfo`
    `static class` | `PredictWindowBase.PredictTaskBase`

    - ### Nested classes/interfaces inherited from class ur_rna.RNAstructureUI.windows.InternalWindow

      `InternalWindow.CommandInfo`

    - ### Nested classes/interfaces inherited from class javax.swing.JInternalFrame

      `javax.swing.JInternalFrame.AccessibleJInternalFrame, javax.swing.JInternalFrame.JDesktopIcon`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static java.lang.String[]` | `controlPrefixes`
    `private java.util.HashMap<javax.swing.JComponent,PredictWindowBase.FieldInfo>` | `fields`
    `private java.util.HashMap<java.lang.String,PredictWindowBase.FileFieldInfo>` | `fileFields`
    `protected java.text.DecimalFormat` | `numberFormatter`
    `protected javax.swing.JPanel` | `pnlClient`
    `protected javax.swing.JPanel` | `pnlContent`
    `private PredictWindowBase.BackgroundTask` | `runningTask`
    `static double` | `TEMP_37C`
    `private javax.swing.Timer` | `uiUpdateTimer`

    - ### Fields inherited from class ur_rna.RNAstructureUI.windows.InternalWindow

      `backend, changeListener, frameListener, log, warnings`

    - ### Fields inherited from class javax.swing.JInternalFrame

      `closable, CONTENT_PANE_PROPERTY, desktopIcon, FRAME_ICON_PROPERTY, frameIcon, GLASS_PANE_PROPERTY, iconable, IS_CLOSED_PROPERTY, IS_ICON_PROPERTY, IS_MAXIMUM_PROPERTY, IS_SELECTED_PROPERTY, isClosed, isIcon, isMaximum, isSelected, LAYERED_PANE_PROPERTY, maximizable, MENU_BAR_PROPERTY, resizable, ROOT_PANE_PROPERTY, rootPane, rootPaneCheckingEnabled, title, TITLE_PROPERTY`

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface javax.swing.WindowConstants

      `DISPOSE_ON_CLOSE, DO_NOTHING_ON_CLOSE, EXIT_ON_CLOSE, HIDE_ON_CLOSE`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PredictWindowBase()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `actionPerformed(java.awt.event.ActionEvent e)`
    `protected void` | `addField(javax.swing.JComponent c, java.lang.String description, java.lang.String settingsName)`
    `protected void` | `addFileField(java.lang.String actionLookupName, javax.swing.text.JTextComponent txt, java.lang.String filters)`
    `protected void` | `addFileField(java.lang.String actionLookupName, javax.swing.text.JTextComponent txt, java.lang.String filters, boolean isOutput)`
    `protected void` | `addFileField(java.lang.String actionLookupName, javax.swing.text.JTextComponent txt, java.lang.String filters, boolean isOutput, java.lang.String action)`
    `protected void` | `autoSetFieldNames()` Automatically set the names of controls (JComponents) that are direct Fields of this class.
    `protected boolean` | `browseFile(javax.swing.text.JTextComponent field, java.lang.String filter, boolean forSave)`
    `protected boolean` | `browseFile(PredictWindowBase.FileFieldInfo field)`
    `protected void` | `browseRecentFile(javax.swing.JComponent displayTarget, PredictWindowBase.FileFieldInfo field)`
    `protected boolean` | `cancelRunningTask()` Cancel the active background task (if there is one) if it is cancelable.
    `protected void` | `enableDescendants(java.awt.Container parent, boolean enabled, java.awt.Component... exclude)`
    `protected void` | `focusField(javax.swing.JComponent c)` Attempts to show the field and set focus to it, possibly by activating the tab on which the control is placed.
    `protected java.lang.String` | `formatValue(java.lang.Object value)`
    `protected boolean` | `frameClosing(javax.swing.event.InternalFrameEvent e)` Indicates that the InternalFrame is closing.
    `protected java.lang.String` | `getControlDescription(javax.swing.JComponent c)`
    `protected java.lang.Object` | `getControlValue(javax.swing.JComponent c)`
    `protected PredictWindowBase.FileFieldInfo` | `getFileField(javax.swing.text.JTextComponent txt, boolean showErrorIfMissing)`
    `protected PredictWindowBase.FileFieldInfo` | `getFileField(java.lang.String fieldName, boolean showErrorIfMissing)`
    `protected PredictWindowBase.BackgroundTask` | `getRunningTask()`
    `protected java.lang.String` | `getSettingsName(javax.swing.JComponent c)`
    `protected java.lang.Number` | `getSpin(javax.swing.JSpinner spn)`
    `protected double` | `getSpinDbl(javax.swing.JSpinner spn)`
    `protected int` | `getSpinInt(javax.swing.JSpinner spn)`
    `protected void` | `handleRecentControlValues(boolean writeValues, java.lang.String nodeName, java.lang.Iterable<javax.swing.JComponent> fields)`
    `protected abstract void` | `handleSettings(boolean writeValues)`
    `protected static DrawingWindow` | `launchDrawing(java.lang.String file, FileType type, java.lang.String addFile, FileType addType, int strand)`
    `protected void` | `listenForActions(javax.swing.AbstractButton... buttons)`
    `protected void` | `listenForActions(javax.swing.JComponent parent)`
    `protected void` | `listenForActions(javax.swing.JComponent parent, java.lang.Class<? extends javax.swing.AbstractButton> type, java.awt.event.ActionListener listener)`
    `protected void` | `loadRecent(java.lang.String nodeName, javax.swing.JComponent... fields)`
    `void` | `pack()`
    `protected <TTask extends PredictWindowBase.BackgroundTask> void` | `runInBackground(TTask task, java.util.function.Consumer<TTask> done)`
    `protected void` | `saveRecent(java.lang.String nodeName, javax.swing.JComponent... fields)`
    `protected void` | `saveRecentFiles(javax.swing.JTextField... fields)`
    `(package private) void` | `setContent(javax.swing.JPanel content)`
    `protected void` | `setControlValue(javax.swing.JComponent c, java.lang.Object value)`
    `protected void` | `setSpin(javax.swing.JSpinner spn, double value)`
    `protected void` | `setSpin(javax.swing.JSpinner spn, double value, double min, double max)`
    `protected void` | `setSpin(javax.swing.JSpinner spn, double value, double min, double max, double step)` Initialize a spinner with a SpinnerNumberModel.
    `protected void` | `setSpin(javax.swing.JSpinner spn, int value)`
    `protected void` | `setSpin(javax.swing.JSpinner spn, int value, int min, int max)`
    `protected void` | `setSpin(javax.swing.JSpinner spn, int value, int min, int max, int step)`
    `void` | `showWindow()` View the window.
    `protected void` | `startUiTimer()`
    `protected void` | `stopUiTimer()`
    `protected java.lang.String` | `stripControlPrefix(java.lang.String name)`
    `protected abstract void` | `updateFormUI()` Called periodically by a timer to update the user interface.
    `protected void` | `validateFailed(javax.swing.JComponent control, java.lang.String message, java.lang.Object... args)`
    `protected void` | `validateFileField(javax.swing.text.JTextComponent txt, boolean allowEmpty)`
    `protected void` | `validateFileField(javax.swing.text.JTextComponent txt, boolean allowEmpty, boolean forOutput)` Verifies the existence of a file in a JTextComponent that has been added as a named file-field.
    `protected void` | `validateRequiredField(javax.swing.text.JTextComponent txt)`

    - ### Methods inherited from class ur_rna.RNAstructureUI.windows.InternalWindow

      `createCustomMenus, frameActivated, frameClosed, getCustomMenus, invokeCommand, invokeCommand, invokeCommand, isActiveFrame, notifyUpdated, onFocusGained, processCommand, propertyChanged, setCaption, setCustomMenus`

    - ### Methods inherited from class javax.swing.JInternalFrame

      `addImpl, addInternalFrameListener, createRootPane, dispose, doDefaultCloseAction, fireInternalFrameEvent, getAccessibleContext, getContentPane, getDefaultCloseOperation, getDesktopIcon, getDesktopPane, getFocusCycleRootAncestor, getFocusOwner, getFrameIcon, getGlassPane, getInternalFrameListeners, getJMenuBar, getLastCursor, getLayer, getLayeredPane, getMenuBar, getMostRecentFocusOwner, getNormalBounds, getRootPane, getTitle, getUI, getUIClassID, getWarningString, hide, isClosable, isClosed, isFocusCycleRoot, isIcon, isIconifiable, isMaximizable, isMaximum, isResizable, isRootPaneCheckingEnabled, isSelected, moveToBack, moveToFront, paintComponent, paramString, remove, removeInternalFrameListener, reshape, restoreSubcomponentFocus, setClosable, setClosed, setContentPane, setCursor, setDefaultCloseOperation, setDesktopIcon, setFocusCycleRoot, setFrameIcon, setGlassPane, setIcon, setIconifiable, setJMenuBar, setLayer, setLayer, setLayeredPane, setLayout, setMaximizable, setMaximum, setMenuBar, setNormalBounds, setResizable, setRootPane, setRootPaneCheckingEnabled, setSelected, setTitle, setUI, show, toBack, toFront, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### controlPrefixes

          private static java.lang.String[] controlPrefixes

    - #### fields

          private java.util.HashMap<javax.swing.JComponent,PredictWindowBase.FieldInfo> fields

    - #### fileFields

          private java.util.HashMap<java.lang.String,PredictWindowBase.FileFieldInfo> fileFields

    - #### numberFormatter

          protected java.text.DecimalFormat numberFormatter

    - #### pnlClient

          protected javax.swing.JPanel pnlClient

    - #### pnlContent

          protected javax.swing.JPanel pnlContent

    - #### runningTask

          private PredictWindowBase.BackgroundTask runningTask

    - #### TEMP_37C

          public static final double TEMP_37C

      See Also:
        Constant Field Values

    - #### uiUpdateTimer

          private javax.swing.Timer uiUpdateTimer

  - ### Constructor Detail

    - #### PredictWindowBase

          public PredictWindowBase()

  - ### Method Detail

    - #### actionPerformed

          public void actionPerformed(java.awt.event.ActionEvent e)

      Specified by:
        `actionPerformed` in interface `java.awt.event.ActionListener`
      Overrides:
        `actionPerformed` in class `InternalWindow`

    - #### addField

          protected void addField(javax.swing.JComponent c,
                                  java.lang.String description,
                                  java.lang.String settingsName)

    - #### addFileField

          protected void addFileField(java.lang.String actionLookupName,
                                      javax.swing.text.JTextComponent txt,
                                      java.lang.String filters)

    - #### addFileField

          protected void addFileField(java.lang.String actionLookupName,
                                      javax.swing.text.JTextComponent txt,
                                      java.lang.String filters,
                                      boolean isOutput)

    - #### addFileField

          protected void addFileField(java.lang.String actionLookupName,
                                      javax.swing.text.JTextComponent txt,
                                      java.lang.String filters,
                                      boolean isOutput,
                                      java.lang.String action)

    - #### autoSetFieldNames

          protected void autoSetFieldNames()

      Automatically set the names of controls (JComponents) that are direct Fields of this class.

    - #### browseFile

          protected boolean browseFile(javax.swing.text.JTextComponent field,
                                       java.lang.String filter,
                                       boolean forSave)

    - #### browseFile

          protected boolean browseFile(PredictWindowBase.FileFieldInfo field)

    - #### browseRecentFile

          protected void browseRecentFile(javax.swing.JComponent displayTarget,
                                          PredictWindowBase.FileFieldInfo field)

    - #### cancelRunningTask

          protected boolean cancelRunningTask()

      Cancel the active background task (if there is one) if it is cancelable. Show a message to the user if the task cannot be canceled at the current time.
      Returns:
        Returns true if there is no task or if it is cancelable. Returns false if the active task cannot be canceled at the current time.

    - #### enableDescendants

          protected void enableDescendants(java.awt.Container parent,
                                           boolean enabled,
                                           java.awt.Component... exclude)

    - #### focusField

          protected void focusField(javax.swing.JComponent c)

      Attempts to show the field and set focus to it, possibly by activating the tab on which the control is placed.
      Parameters:
        `c` - The JComponent to show and set focus to.

    - #### formatValue

          protected java.lang.String formatValue(java.lang.Object value)

    - #### frameClosing

          protected boolean frameClosing(javax.swing.event.InternalFrameEvent e)

      Description copied from class: `InternalWindow`
      Indicates that the InternalFrame is closing. Return true to allow the window to close, or return false to prevent it.
      Overrides:
        `frameClosing` in class `InternalWindow`
      Returns:

    - #### getControlDescription

          protected java.lang.String getControlDescription(javax.swing.JComponent c)

    - #### getControlValue

          protected java.lang.Object getControlValue(javax.swing.JComponent c)

    - #### getFileField

          protected PredictWindowBase.FileFieldInfo getFileField(javax.swing.text.JTextComponent txt,
                                                                 boolean showErrorIfMissing)

    - #### getFileField

          protected PredictWindowBase.FileFieldInfo getFileField(java.lang.String fieldName,
                                                                 boolean showErrorIfMissing)

    - #### getRunningTask

          protected PredictWindowBase.BackgroundTask getRunningTask()

    - #### getSettingsName

          protected java.lang.String getSettingsName(javax.swing.JComponent c)

    - #### getSpin

          protected java.lang.Number getSpin(javax.swing.JSpinner spn)

    - #### getSpinDbl

          protected double getSpinDbl(javax.swing.JSpinner spn)

    - #### getSpinInt

          protected int getSpinInt(javax.swing.JSpinner spn)

    - #### handleRecentControlValues

          protected void handleRecentControlValues(boolean writeValues,
                                                   java.lang.String nodeName,
                                                   java.lang.Iterable<javax.swing.JComponent> fields)

    - #### handleSettings

          protected abstract void handleSettings(boolean writeValues)

    - #### launchDrawing

          protected static DrawingWindow launchDrawing(java.lang.String file,
                                                       FileType type,
                                                       java.lang.String addFile,
                                                       FileType addType,
                                                       int strand)

    - #### listenForActions

          protected void listenForActions(javax.swing.AbstractButton... buttons)

    - #### listenForActions

          protected void listenForActions(javax.swing.JComponent parent)

    - #### listenForActions

          protected void listenForActions(javax.swing.JComponent parent,
                                          java.lang.Class<? extends javax.swing.AbstractButton> type,
                                          java.awt.event.ActionListener listener)

    - #### loadRecent

          protected void loadRecent(java.lang.String nodeName,
                                    javax.swing.JComponent... fields)

    - #### pack

          public void pack()

      Overrides:
        `pack` in class `javax.swing.JInternalFrame`

    - #### runInBackground

          protected <TTask extends PredictWindowBase.BackgroundTask> void runInBackground(TTask task,
                                                                                          java.util.function.Consumer<TTask> done)

    - #### saveRecent

          protected void saveRecent(java.lang.String nodeName,
                                    javax.swing.JComponent... fields)

    - #### saveRecentFiles

          protected void saveRecentFiles(javax.swing.JTextField... fields)

    - #### setContent

          void setContent(javax.swing.JPanel content)

    - #### setControlValue

          protected void setControlValue(javax.swing.JComponent c,
                                         java.lang.Object value)

    - #### setSpin

          protected void setSpin(javax.swing.JSpinner spn,
                                 double value)

    - #### setSpin

          protected void setSpin(javax.swing.JSpinner spn,
                                 double value,
                                 double min,
                                 double max)

    - #### setSpin

          protected void setSpin(javax.swing.JSpinner spn,
                                 double value,
                                 double min,
                                 double max,
                                 double step)

      Initialize a spinner with a SpinnerNumberModel.
      Parameters:
        `spn` - The spinner
        `value` - The initial value.
        `min` - The minimum value.
        `max` - The maximim value.
        `step` - Teh step size.

    - #### setSpin

          protected void setSpin(javax.swing.JSpinner spn,
                                 int value)

    - #### setSpin

          protected void setSpin(javax.swing.JSpinner spn,
                                 int value,
                                 int min,
                                 int max)

    - #### setSpin

          protected void setSpin(javax.swing.JSpinner spn,
                                 int value,
                                 int min,
                                 int max,
                                 int step)

    - #### showWindow

          public void showWindow()

      Description copied from class: `InternalWindow`
      View the window.
      Overrides:
        `showWindow` in class `InternalWindow`

    - #### startUiTimer

          protected void startUiTimer()

    - #### stopUiTimer

          protected void stopUiTimer()

    - #### stripControlPrefix

          protected java.lang.String stripControlPrefix(java.lang.String name)

    - #### updateFormUI

          protected abstract void updateFormUI()

      Called periodically by a timer to update the user interface.

    - #### validateFailed

          protected void validateFailed(javax.swing.JComponent control,
                                        java.lang.String message,
                                        java.lang.Object... args)
                                 throws FormValidationException

      Throws:
        `FormValidationException`

    - #### validateFileField

          protected void validateFileField(javax.swing.text.JTextComponent txt,
                                           boolean allowEmpty)
                                    throws FormValidationException

      Throws:
        `FormValidationException`

    - #### validateFileField

          protected void validateFileField(javax.swing.text.JTextComponent txt,
                                           boolean allowEmpty,
                                           boolean forOutput)
                                    throws FormValidationException

      Verifies the existence of a file in a JTextComponent that has been added as a named file-field.
      Parameters:
        `txt` - The JTextComponent used to accept file entry.
        `allowEmpty` - Whether the field is optional (and so can be empty and still be valid input).
        `forOutput` - Whether the field is the name of an output file. (If so, it does not need to exist, but must be in a valid directory.
      Throws:
        `FormValidationException` - if txt fails validation.

    - #### validateRequiredField

          protected void validateRequiredField(javax.swing.text.JTextComponent txt)
                                        throws FormValidationException

      Throws:
        `FormValidationException`